Developer
News and Updates
Get Support
Sign in
Get Support
Sign in
DOCUMENTATION
Cloud
Data Center
Resources
Sign in
Sign in
DOCUMENTATION
Cloud
Data Center
Resources
Sign in
  • Announcement banner
  • App data policies
  • App migration
  • App properties
  • Application roles
  • Audit records
  • Avatars
  • Classification levels
  • Dashboards
  • Dynamic modules
  • Field schemes
  • Filter sharing
  • Filters
  • Group and user picker
  • Groups
  • Issue attachments
  • Issue comment properties
  • Issue comments
  • Issue custom field associations
  • Issue custom field configuration (apps)
  • Issue custom field contexts
  • Issue custom field options
  • Issue custom field options (apps)
  • Issue custom field values (apps)
  • Issue field configurations
  • Issue fields
  • Issue navigator settings
  • Issue notification schemes
  • Issue panels
  • Issue priorities
  • Issue properties
  • Issue redaction
  • Issue resolutions
  • Issue security level
  • Issue security schemes
  • Issue type properties
  • Issue type schemes
  • Issue type screen schemes
  • Issue types
  • Issue votes
  • Issue watchers
  • Issue worklog properties
  • Issue worklogs
  • Issues
  • JQL
  • JQL functions (apps)
  • Jira expressions
  • Jira settings
  • Labels
  • License metrics
  • Migration of Connect modules to Forge
  • Myself
  • Permission schemes
  • Permissions
  • Plans
  • Priority schemes
  • Project avatars
  • Project categories
  • Project classification levels
  • Project components
  • Project email
  • Project features
  • Project key and name validation
  • Project permission schemes
  • Project properties
  • Project role actors
  • Project roles
  • Project templates
  • Project types
  • Project versions
  • Projects
  • Screen schemes
  • Screen tab fields
  • Screen tabs
  • Screens
  • Server info
  • Service Registry
  • Status
  • Tasks
  • Teams in plan
  • Time tracking
  • UI modifications (apps)
  • User properties
  • Users
  • Webhooks
  • Workflow scheme drafts
  • Workflow scheme project associations
  • Workflow schemes
  • Workflow status categories
  • Workflow statuses
  • Workflow transition rules
  • Workflows
  • Other operations
Cloud
Jira Cloud platform / Reference / REST API v2

Project templates

Postman Collection
OpenAPI
POST

Create custom project

Creates a project based on a custom template provided in the request.

The request body should contain the project details and the capabilities that comprise the project:

  • details - represents the project details settings
  • template - represents a list of capabilities responsible for creating specific parts of a project

A capability is defined as a unit of configuration for the project you want to create.

This operation is:

  • asynchronous. Follow the Location link in the response header to determine the status of the task and use Get task to obtain subsequent updates.

Note: This API is only supported for Jira Enterprise edition.

Permissions required: Administer Jira global permission.

Data Security Policy: Exempt from app access rules
Scopes
ClassicRECOMMENDED:manage:jira-configuration
Granular:write:project:jira, read:project:jira

Connect apps cannot access this REST resource.

Request

Request bodyapplication/json

The JSON payload containing the project details and capabilities

details

CustomTemplatesProjectDetails

template

CustomTemplateRequestDTO

Responses

The project creation task has been queued for execution

application/json

any

POST/rest/api/2/project-template
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100 101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147 148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169 170 171 172 173 174 175 176 177 178 179 180 181 182 183 184 185 186 187 188 189 190 191 192 193 194 195 196 197 198 199 200 201 202 203 204 205 206 207 208 209 210 211 212 213 214 215 216 217 218 219 220 221 222 223 224 225 226 227 228 229 230 231 232 233 234 235 236 237 238 239 240 241 242 243 244 245 246 247 248 249 250 251 252 253 254 255 256 257 258 259 260 261 262 263 264 265 266 267 268 269 270 271 272 273 274 275 276 277 278 279 280 281 282 283 284 285 286 287 288 289 290 291 292 293 294 295 296 297 298 299 300 301 302 303 304 305 306 307 308 309 310 311 312 313 314 315 316 317 318 319 320 321 322 323 324 325 326 327 328 329 330 331 332 333 334 335 336 337 338 339 340 341 342 343 344 345 346 347 348 349 350 351 352 353 354 355 356 357 358 359 360 361 362 363 364 365 366 367 368 369 370 371 372 373 374 375 376 377 378 379 380 381 382 383 384 385 386 387 388 389 390 391 392 393 394 395 396 397 398 399 400 401 402 403 404 405 406 407 408 409 410 411 412 413 414 415 416 417 418 419 420 421 422 423 424 425 426 427 428 429 430 431 432 433 434 435 436 437 438 439 440 441 442 443 444 445 446 447 // This sample uses Atlassian Forge // https://developer.atlassian.com/platform/forge/ import { requestJira } from "@forge/bridge"; var bodyData = `{ "details": { "additionalProperties": {}, "assigneeType": "PROJECT_LEAD", "avatarId": 1, "categoryId": 1, "currencyCode": "USD", "description": "description", "enableComponents": false, "key": "key", "language": "EN-US", "leadAccountId": "leadAccountId", "name": "name", "projectTypeKey": "software", "url": "url", "useSystemDefaultPermissionSchemeAndRole": false }, "template": { "boardFeatures": { "boardFeatures": { "pcri:board:ref:board1": [ { "featureKey": "SPRINTS", "state": true } ] } }, "boards": { "boards": [ { "boardFilterJQL": "project = 'My Project'", "cardLayout": { "showDaysInColumn": true }, "columns": [ { "name": "TODO", "statusIds": [ "pcri:status:ref:todo" ] } ], "name": "My Board", "pcri": "pcri:board:ref:board1", "quickFilters": [ { "description": "This is a quick filter for my project", "jqlQuery": "project = 'My Project'", "name": "My Quick Filter" } ], "supportsSprint": true, "swimlanes": { "customSwimlanes": [ { "description": "This is a swimlane for my project", "jqlQuery": "project = 'My Project'", "name": "My Swimlane" } ], "defaultCustomSwimlaneName": "My Swimlane", "swimlaneStrategy": "none" } } ] }, "field": { "customFieldDefinitions": [ { "cfType": "com.atlassian.jira.plugin.system.customfieldtypes:textfield", "description": "This is a custom field", "name": "Custom Field 1", "onConflict": "FAIL", "pcri": "pcri:field:ref:customField1", "searcherKey": "com.atlassian.jira.plugin.system.customfieldtypes:textsearcher" } ], "fieldContexts": [], "fieldLayoutScheme": { "defaultFieldLayout": "pcri:fieldLayout:ref:fieldLayout1", "description": "This is a field layout scheme", "explicitMappings": { "pcri:issueType:ref:default": "pcri:fieldLayout:ref:fieldLayout2" }, "name": "Field Layout Scheme 1", "pcri": "pcri:fieldLayoutScheme:ref:fls1" }, "fieldLayouts": [ { "configuration": [ { "pcri": "pcri:field:id:summary", "required": false, "show": true } ], "description": "This is a field layout", "name": "Field Layout 1", "pcri": "pcri:fieldLayout:ref:fieldLayout1" } ], "fieldScheme": { "description": "This is a field scheme", "items": [], "name": "Field Scheme 1", "onConflict": "USE", "pcri": "pcri:fieldScheme:id:fieldScheme1" }, "issueLayouts": [ { "containerId": "pcri:issueType:ref:epic", "issueLayoutType": "ISSUE_VIEW", "items": [ { "itemKey": "pcri:field:id:summary", "properties": { "jsd.field.displayName": "sd.premade.project.servicedesk.common.requesttype.email.field.summary" }, "sectionType": "content", "type": "FIELD" } ], "pcri": "pcri:issueLayout:ref:issueLayout1" } ], "issueTypeScreenScheme": { "defaultScreenScheme": "pcri:screenScheme:ref:defaultScreenScheme", "description": "This is an issue type screen scheme", "explicitMappings": { "pcri:issueType:ref:issueType1": "pcri:screenScheme:ref:screenScheme1" }, "name": "Issue Type Screen Scheme 1", "pcri": "pcri:issuetypeScreenScheme:ref:issuetypeScreenSchemeRef1" }, "projectTemplateSource": "LIVE", "screenScheme": [ { "defaultScreen": "pcri:screen:ref:default", "description": "This is a screen scheme", "explicitMappings": { "create": "pcri:screen:ref:createScreen", "edit": "pcri:screen:ref:editScreen", "view": "pcri:screen:ref:viewScreen" }, "name": "Screen Scheme 1", "pcri": "pcri:screenScheme:ref:screenScheme1" } ], "screens": [ { "description": "This is a screen", "name": "Screen 1", "pcri": "pcri:screen:ref:screen1", "tabs": [ { "fields": [ "pcri:field:ref:field1", "pcri:field:ref:field2" ], "name": "Tab 1" } ] } ] }, "issueType": { "issueTypeHierarchy": [ { "hierarchyLevel": 0, "name": "Task issue type hierachy", "onConflict": "USE", "pcri": "pcri:issueTypeHierachy:ref:issueTypeHierachy1" } ], "issueTypeScheme": { "defaultIssueTypeId": "pcri:issueType:ref:default", "description": "Test Issue Type Scheme description", "issueTypeIds": [ "pcri:issueType:ref:default", "pcri:issueType:id:10000" ], "name": "Test Issue Type Scheme", "pcri": "pcri:issueTypeScheme:ref:its" }, "issueTypes": [ { "avatarId": 10, "description": "Test issue type description", "hierarchyLevel": 0, "name": "Test issue type", "onConflict": "USE", "pcri": "pcri:issueType:ref:default", "permitedOperations": { "deletable": false, "editable": true } } ] }, "notification": { "description": "Description", "name": "Simplified Notification Scheme", "notificationSchemeEvents": [ { "event": { "id": "1" }, "notifications": [ { "notificationType": "CurrentAssignee" } ] } ], "onConflict": "USE", "pcri": "pcri:notificationScheme:ref:notification1" }, "permissionScheme": { "addAddonRole": true, "description": "This is an example permission scheme", "grants": [ { "applicationAccess": [], "groupCustomFields": [], "groups": [], "permissionKeys": [ "ADMINISTER_PROJECTS", "BROWSE_PROJECTS" ], "projectRoles": [ "pcri:role:ref:admin" ], "specialGrants": [], "userCustomFields": [], "users": [] } ], "name": "Example Permission Scheme", "onConflict": "USE", "pcri": "pcri:permissionScheme:ref:scheme" }, "project": { "fieldLayoutSchemeId": "pcri:fieldLayoutScheme:id:10001", "issueSecuritySchemeId": "pcri:issueSecurityScheme:id:10001", "issueTypeSchemeId": "pcri:issueTypeScheme:id:10001", "issueTypeScreenSchemeId": "pcri:issueTypeScreenScheme:id:10001", "notificationSchemeId": "pcri:notificationScheme:id:10001", "pcri": "pcri:project:ref:newProject1", "permissionSchemeId": "pcri:permissionScheme:id:10001", "projectTypeKey": "software", "workflowSchemeId": "pcri:workflowScheme:id:10001" }, "role": { "roleToProjectActors": { "pcri:role:ref:role1": [ "pcri:user:id:1" ], "pcri:role:ref:role2": [ "pcri:user:id:2" ] }, "roles": [ { "defaultActors": [ "pcri:user:id:1", "pcri:user:id:2" ], "description": "Administrator role with all permissions", "name": "Admin Role", "onConflict": "FAIL", "pcri": "pcri:role:ref:role1", "type": "EDITABLE" }, { "description": "Regular user role with limited permissions", "name": "User Role", "onConflict": "FAIL", "pcri": "pcri:role:ref:role2", "type": "VIEWABLE" } ] }, "scope": { "type": "GLOBAL" }, "security": { "description": "Newly created issue security scheme", "name": "New Security Scheme", "pcri": "pcri:issueSecurityScheme:ref:newIssueSecurityScheme", "securityLevels": [ { "description": "Newly created issue security level", "isDefault": true, "name": "New Security Level", "pcri": "pcri:issueSecurityLevel:ref:new-security-level", "securityLevelMembers": [ { "parameter": "administrators", "type": "group" } ] } ] }, "workflow": { "statuses": [ { "description": "To Do Status", "name": "To Do", "onConflict": "USE", "pcri": "pcri:status:ref:todo", "statusCategory": "TODO" }, { "description": "In Progress Status", "name": "In Progress", "onConflict": "USE", "pcri": "pcri:status:ref:inprogress", "statusCategory": "IN_PROGRESS" }, { "description": "Done Status", "name": "Done", "onConflict": "USE", "pcri": "pcri:status:ref:done", "statusCategory": "DONE" } ], "workflowScheme": { "defaultWorkflow": "pcri:workflow:ref:workflow1", "description": "Description", "name": "New Workflow scheme for Project Custom Template", "pcri": "pcri:workflowScheme:ref:workflowSchemeRef1" }, "workflows": [ { "description": "a software workflow", "loopedTransitionContainerLayout": { "x": 1, "y": 2 }, "name": "Software Simplified Workflow for Project", "onConflict": "NEW", "pcri": "pcri:workflow:ref:workflow", "startPointLayout": { "x": 1, "y": 2 }, "statuses": [ { "layout": { "x": 1, "y": 2 }, "pcri": "pcri:status:ref:todo", "properties": { "key": "value" } } ], "transitions": [ { "actions": [], "description": "To do transition", "from": [], "id": 11, "name": "To Do", "properties": { "jira.i18n.title": "gh.workflow.preset.todo" }, "to": { "status": "pcri:status:ref:todo" }, "triggers": [], "type": "GLOBAL", "validators": [] }, { "actions": [], "description": "In Progress Transition", "from": [], "id": 21, "name": "In Progress", "properties": { "jira.i18n.title": "gh.workflow.preset.inprogress" }, "to": { "status": "pcri:status:ref:inprogress" }, "triggers": [], "type": "GLOBAL", "validators": [] }, { "actions": [], "description": "Done Transition", "from": [], "id": 31, "name": "Done", "properties": { "jira.i18n.title": "gh.workflow.preset.done" }, "to": { "status": "pcri:status:ref:done" }, "triggers": [], "type": "GLOBAL", "validators": [] }, { "actions": [], "description": "Start transition", "from": [], "id": 1, "name": "Create", "properties": { "jira.i18n.title": "gh.workflow.preset.todo" }, "to": { "status": "pcri:status:ref:todo" }, "triggers": [], "type": "INITIAL", "validators": [] } ] } ] } } }`; const response = await requestJira(`/rest/api/2/project-template`, { method: 'POST', headers: { 'Content-Type': 'application/json' }, body: bodyData }); console.log(`Response: ${response.status} ${response.statusText}`); console.log(await response.text());
PUT

Edit a custom project templateExperimental

Edit custom template

This API endpoint allows you to edit an existing customised template.

Note: Custom Templates are only supported for Jira Enterprise edition.

Data Security Policy: Exempt from app access rules
Scopes
ClassicRECOMMENDED:manage:jira-configuration
Granular:write:project:jira, read:project:jira

Connect apps cannot access this REST resource.

Request

Request bodyapplication/json

The object containing the updated template details: name, description

templateDescription

string

templateGenerationOptions

CustomTemplateOptions

templateKey

string

templateName

string

Responses

200 response

application/json

any

PUT/rest/api/2/project-template/edit-template
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 // This sample uses Atlassian Forge // https://developer.atlassian.com/platform/forge/ import { requestJira } from "@forge/bridge"; var bodyData = `{ "templateDescription": "<string>", "templateGenerationOptions": { "enableScreenDelegatedAdminSupport": true, "enableWorkflowDelegatedAdminSupport": true }, "templateKey": "<string>", "templateName": "<string>" }`; const response = await requestJira(`/rest/api/2/project-template/edit-template`, { method: 'PUT', headers: { 'Accept': 'application/json', 'Content-Type': 'application/json' }, body: bodyData }); console.log(`Response: ${response.status} ${response.statusText}`); console.log(await response.json());
GET

Gets a custom project templateExperimental

Get custom template

This API endpoint allows you to get a live custom project template details by either templateKey or projectId

Note: Custom Templates are only supported for Jira Enterprise edition.

Data Security Policy: Exempt from app access rules
Scopes
ClassicRECOMMENDED:manage:jira-configuration
Granular:write:project:jira, read:project:jira

Connect apps cannot access this REST resource.

Request

Query parameters

projectId

string

templateKey

string

Responses

200 response

application/json

ProjectTemplateModel
GET/rest/api/2/project-template/live-template
1 2 3 4 5 6 7 8 9 10 11 12 // This sample uses Atlassian Forge // https://developer.atlassian.com/platform/forge/ import { requestJira } from "@forge/bridge"; const response = await requestJira(`/rest/api/2/project-template/live-template`, { headers: { 'Accept': 'application/json' } }); console.log(`Response: ${response.status} ${response.statusText}`); console.log(await response.json());
200Response
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 { "archetype": { "realType": "BUSINESS", "style": "classic", "type": "BUSINESS" }, "defaultBoardView": "<string>", "description": "<string>", "liveTemplateProjectIdReference": 2154, "name": "<string>", "projectTemplateKey": { "key": "<string>", "uuid": "<string>" }, "snapshotTemplate": {}, "templateGenerationOptions": { "enableScreenDelegatedAdminSupport": true, "enableWorkflowDelegatedAdminSupport": true }, "type": "LIVE" }
DEL

Deletes a custom project templateExperimental

Remove custom template

This API endpoint allows you to remove a specified customised template

Note: Custom Templates are only supported for Jira Enterprise edition.

Data Security Policy: Exempt from app access rules
Scopes
ClassicRECOMMENDED:manage:jira-configuration
Granular:write:project:jira, read:project:jira

Connect apps cannot access this REST resource.

Request

Query parameters

templateKey

string

Required

Responses

200 response

application/json

any

DEL/rest/api/2/project-template/remove-template
1 2 3 4 5 6 7 8 9 10 11 12 13 // This sample uses Atlassian Forge // https://developer.atlassian.com/platform/forge/ import { requestJira } from "@forge/bridge"; const response = await requestJira(`/rest/api/2/project-template/remove-template?templateKey={templateKey}`, { method: 'DELETE', headers: { 'Accept': 'application/json' } }); console.log(`Response: ${response.status} ${response.statusText}`); console.log(await response.json());
POST

Save a custom project templateExperimental

Save custom template

This API endpoint allows you to save a customised template

Note: Custom Templates are only supported for Jira Enterprise edition.

Data Security Policy: Exempt from app access rules
Scopes
ClassicRECOMMENDED:manage:jira-configuration
Granular:write:project:jira, read:project:jira

Connect apps cannot access this REST resource.

Request

Request bodyapplication/json

The object containing the template basic details: name, description

templateDescription

string

templateFromProjectRequest

SaveProjectTemplateRequest

templateName

string

Responses

200 response

application/json

SaveTemplateResponse
POST/rest/api/2/project-template/save-template
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 // This sample uses Atlassian Forge // https://developer.atlassian.com/platform/forge/ import { requestJira } from "@forge/bridge"; var bodyData = `{ "templateDescription": "<string>", "templateFromProjectRequest": { "projectId": 28, "templateGenerationOptions": { "enableScreenDelegatedAdminSupport": true, "enableWorkflowDelegatedAdminSupport": true }, "templateType": "LIVE" }, "templateName": "<string>" }`; const response = await requestJira(`/rest/api/2/project-template/save-template`, { method: 'POST', headers: { 'Accept': 'application/json', 'Content-Type': 'application/json' }, body: bodyData }); console.log(`Response: ${response.status} ${response.statusText}`); console.log(await response.json());
200Response
1 2 3 4 5 6 { "projectTemplateKey": { "key": "<string>", "uuid": "<string>" } }

Rate this page: